FETESTEXCEPT(3P)

NAME
fetestexcept - test floating-point exception flags

SYNOPSIS

#include <fenv.h>

int fetestexcept(int excepts);

DESCRIPTION

The fetestexcept() function shall determine which of a specified subset of the floating-point exception flags are currently set. The excepts argument specifies the floating-point status flags to be queried.

RETURN VALUE

The fetestexcept() function shall return the value of the bitwise-inclusive OR of the floating-point exception macros corresponding to the currently set floating-point exceptions included in excepts.

ERRORS

No errors are defined.

The following sections are informative.

EXAMPLES

The following example calls function f() if an invalid exception is set, and then function g() if an overflow exception is set:

    #include <fenv.h>
    /* ... */
    {
        #pragma STDC FENV_ACCESS ON
        int set_excepts;
        feclearexcept(FE_INVALID | FE_OVERFLOW);
        // maybe raise exceptions
        set_excepts = fetestexcept(FE_INVALID | FE_OVERFLOW);
        if (set_excepts & FE_INVALID) f();
        if (set_excepts & FE_OVERFLOW) g();
        /* ... */
    }

APPLICATION USAGE

None.

RATIONALE

None.

FUTURE DIRECTIONS

None.

SEE ALSO

feclearexcept() , fegetexceptflag() , feraiseexcept() , the Base Definitions volume of IEEE Std 1003.1-2001, <fenv.h>

COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .